## Loops when the game is active

# Death check
execute as @a[scores={Deaths=1..}] at @s run function votk:core/player_death
execute as @e[type=player,tag=respawn] run function votk:core/respawn

# Arrow kill check
execute as @e[type=arrow] run kill @s[nbt={inGround:1b}]

# Keep players out of enemy spawns
tp @a[x=191,y=141,z=192,dx=4,dy=4,dz=3,team=Archaeologists] 193 139 190 180 0
tp @a[x=160,y=137,z=176,dx=1,dy=2,dz=3,team=Archaeologists] 161 137 174 180 0
tp @a[x=163,y=141,z=-164,dx=4,dy=3,dz=3,team=Egyptians] 165 139 -159 0 0
tp @a[x=192,y=141,z=-164,dx=4,dy=3,dz=3,team=Egyptians] 194 140 -159 0 0

# Refresh inventory when an item is dropped
execute as @e[type=item,tag=!elytra] at @s as @p run function votk:core/new_inv
kill @e[type=item,tag=!elytra]

# Kill anyone who drank from the forbidden potion
kill @a[scores={drinkPotion=1..}]
execute as @a[scores={drinkPotion=1..}] run function votk:core/new_inv
scoreboard players reset @a drinkPotion

# Flag effects
execute as @e[type=armor_stand,tag=redFlag] at @s run tp @s ~ ~ ~ ~-2 ~
execute as @e[type=armor_stand,tag=blueFlag] at @s run tp @s ~ ~ ~ ~-2 ~

execute at @e[type=armor_stand,tag=redFlag] run particle falling_dust red_concrete ~ ~100 ~ 0.05 50 0.05 0 50 force
execute at @a[tag=hasRedFlag] run particle falling_dust red_concrete ~ ~100 ~ 0.05 50 0.05 0 50 force

execute at @e[type=armor_stand,tag=blueFlag] run particle falling_dust blue_concrete ~ ~100 ~ 0.05 50 0.05 0 50 force
execute at @a[tag=hasBlueFlag] run particle falling_dust blue_concrete ~ ~100 ~ 0.05 50 0.05 0 50 force

# Elytra effects
execute at @a[scores={flying=1000..},team=Egyptians] run particle block blue_concrete ~ ~ ~ 0.5 0.5 0.5 0.1 5 force
execute at @a[scores={flying=1000..},team=Archaeologists] run particle block red_concrete ~ ~ ~ 0.5 0.5 0.5 0.1 5 force

# Arrow effects
execute as @e[type=arrow,tag=!redArrow,tag=!blueArrow] at @s if entity @e[team=Archaeologists,distance=..2] run tag @s add redArrow
execute as @e[type=arrow,tag=!redArrow,tag=!blueArrow] at @s if entity @e[team=Egyptians,distance=..2] run tag @s add blueArrow
execute at @e[type=arrow,tag=redArrow] run particle block red_wool ~ ~.2 ~ .1 .1 .1 0.1 5 force
execute at @e[type=arrow,tag=blueArrow] run particle block blue_wool ~ ~.2 ~ .1 .1 .1 0.1 5 force



# Flag grab detection (on player)
execute as @e[type=armor_stand,tag=redFlag] at @s as @p[dy=2,team=Egyptians,tag=!respawn] run function votk:flag/grab_red_flag
execute as @e[type=armor_stand,tag=blueFlag] at @s as @p[dy=2,team=Archaeologists,tag=!respawn] run function votk:flag/grab_blue_flag

# Flag return detection (on flag)
execute as @e[type=armor_stand,tag=redFlag] at @s if entity @p[dy=2,team=Archaeologists,tag=!respawn] unless entity @e[type=area_effect_cloud,tag=redBase,distance=..2] run function votk:flag/return_red_flag
execute as @e[type=armor_stand,tag=blueFlag] at @s if entity @p[dy=2,team=Egyptians,tag=!respawn] unless entity @e[type=area_effect_cloud,tag=blueBase,distance=..2] run function votk:flag/return_blue_flag

# Flag capture detection (on player)
execute as @a[tag=hasRedFlag] at @s if entity @e[type=area_effect_cloud,tag=blueBase,distance=..3] run function votk:flag/capture_red_flag
execute as @a[tag=hasBlueFlag] at @s if entity @e[type=area_effect_cloud,tag=redBase,distance=..3] run function votk:flag/capture_blue_flag



## Elytra tunnel teleports
# Actual teleports
execute as @a at @s run tp @s[x=192,y=141,z=220,dx=1,dy=3,dz=2] ~123 ~17 ~-193
execute as @a at @s run tp @s[x=182,y=126,z=-153,dx=1,dy=3,dz=3] ~131 ~32 ~138

# Catch those caught in the ground afterward
execute as @a at @s run tp @s[x=312,y=157,z=-15,dx=3,dy=0,dz=3] ~ ~1 ~
execute as @a at @s run tp @s[x=314,y=157,z=27,dx=3,dy=0,dz=3] ~ ~1 ~



## Elytra stuff
# Elytra gate checks
execute unless block 180 140 -171 oak_fence as @a[x=178,y=135,z=-170,dx=3,dy=5,dz=2,team=!Spectators] run function votk:elytra/gate_close_red
execute unless block 177 142 204 oak_fence as @a[x=176,y=141,z=205,dx=2,dy=3,dz=2,team=!Spectators] run function votk:elytra/gate_close_blue

# Detect broken elytra
execute as @a[tag=hasElytra,scores={flying=1000..},nbt={Inventory:[{id:"minecraft:elytra",tag:{Damage:431}}]}] run function votk:elytra/break_elytra
execute as @a[tag=hasElytra,scores={flying=1000..},nbt={OnGround:1b}] run function votk:elytra/break_elytra
execute as @a[tag=hasElytra,tag=hasRedFlag] run function votk:elytra/break_elytra
execute as @a[tag=hasElytra,tag=hasBlueFlag] run function votk:elytra/break_elytra
execute as @a[tag=hasElytra] at @s if entity @s[y=164,dy=100] run function votk:elytra/break_elytra

# Elytra respawn effect countdown
execute if score elytraRespawn2 timer matches ..0 run function votk:elytra/spawn_elytra
execute if score elytraRespawn2 timer matches 1.. run scoreboard players remove elytraRespawn2 timer 1

# See if a player has found the elytra but still has a flag so they can't pick it up
execute at @e[tag=elytra] as @a[distance=..1,tag=hasRedFlag] unless score @s elytraCooldown matches 1.. run tellraw @s {"text":"The flag is too heavy to equip the Scarab Elytra!","color":"gray","italic":"true"}
execute at @e[tag=elytra] as @a[distance=..1,tag=hasBlueFlag] unless score @s elytraCooldown matches 1.. run tellraw @s {"text":"The flag is too heavy to equip the Scarab Elytra!","color":"gray","italic":"true"}

execute at @e[tag=elytra] as @a[distance=..1,tag=hasRedFlag] at @s unless score @s elytraCooldown matches 1.. run playsound item.shovel.flatten master @s ~ ~ ~ 1 2
execute at @e[tag=elytra] as @a[distance=..1,tag=hasBlueFlag] at @s unless score @s elytraCooldown matches 1.. run playsound item.shovel.flatten master @s ~ ~ ~ 1 2

execute at @e[tag=elytra] as @a[distance=..1,tag=hasRedFlag] unless score @s elytraCooldown matches 1.. run scoreboard players set @s elytraCooldown 100
execute at @e[tag=elytra] as @a[distance=..1,tag=hasBlueFlag] unless score @s elytraCooldown matches 1.. run scoreboard players set @s elytraCooldown 100

scoreboard players reset @a[scores={elytraCooldown=0}] elytraCooldown
scoreboard players remove @a[scores={elytraCooldown=1..}] elytraCooldown 1

# See if a player has found the elytra and actually can pick it up
execute at @e[tag=elytra] as @a[distance=..1,tag=!respawn,tag=!hasBlueFlag,tag=!hasRedFlag,tag=!hasElytra,team=!Spectators] run function votk:elytra/find_elytra



# Countdown the AIrespawn clock
scoreboard players remove @e[tag=AIspawnpoint,scores={AIrespawn=1..}] AIrespawn 1
execute at @e[tag=AIspawnpoint,scores={AIrespawn=50}] run particle portal ~ ~1 ~ 0.1 0.1 0.1 1 100 force @a
execute at @e[tag=AIspawnpoint,scores={AIrespawn=50}] run playsound block.portal.trigger master @a ~ ~ ~ 0.2 1.7
execute as @e[tag=AIspawnpoint,tag=Archaeologists,scores={AIrespawn=..0}] at @s run function votk:ai/spawn_red_ai
execute as @e[tag=AIspawnpoint,tag=Egyptians,scores={AIrespawn=..0}] at @s run function votk:ai/spawn_blue_ai

# Update the AI based on range
execute as @e[team=Archaeologists,tag=AI,tag=farRange] at @s if entity @p[team=Egyptians,distance=..4] run function votk:ai/close_range
execute as @e[team=Archaeologists,tag=AI,tag=closeRange] at @s unless entity @p[team=Egyptians,distance=..4] run function votk:ai/far_range
execute as @e[team=Egyptians,tag=AI,tag=farRange] at @s if entity @p[team=Archaeologists,distance=..4] run function votk:ai/close_range
execute as @e[team=Egyptians,tag=AI,tag=closeRange] at @s unless entity @p[team=Archaeologists,distance=..4] run function votk:ai/far_range

# Check for dying AI
execute as @e[tag=AI,nbt={HurtTime:10s}] run function votk:ai/dying_ai



# Check for logouts with elytra or flags
execute unless entity @e[tag=hasRedFlag] unless entity @e[tag=redFlag] run function votk:flag/return_red_flag
execute unless entity @e[tag=hasBlueFlag] unless entity @e[tag=blueFlag] run function votk:flag/return_blue_flag
execute unless score elytraRespawn timer matches 0.. unless score elytraRespawn2 timer matches 0.. unless entity @e[tag=elytra] unless entity @e[tag=hasElytra] run scoreboard players set elytraRespawn timer 20



# Spectator boundaries
execute as @a[team=Spectators] at @s run tp @s[y=94,dy=10] ~ ~10 ~
execute as @a[team=Spectators] at @s run tp @s[y=250,dy=10] ~ ~-10 ~

execute as @a[team=Spectators] at @s run tp @s[x=100,dx=10] ~10 ~ ~
execute as @a[team=Spectators] at @s run tp @s[x=329,dx=10] ~-10 ~ ~

execute as @a[team=Spectators] at @s run tp @s[z=-203,dz=10] ~ ~ ~10
execute as @a[team=Spectators] at @s run tp @s[z=226,dz=10] ~ ~ ~-10