## Options Menu (click-based)
# Runs on players who have triggered an "options" scoreboard (while lobby active)

# OPTIONS NUMBERS:
# 0 - Clear (default)
# 1 - Main Options
# 2 - Game Length
# 3 - Help Menu
# 4 - Start Game (Confirmation Screen)
# 5 - AI Settings
# 6 - Dec. AI Count
# 7 - Inc. AI Count
# 8 - Dec. Game Time
# 9 - Inc. Game Time
# 10 - Help (Map Layout)
# 11 - Help (Flag)
# 12 - Help (Elytra)
# 13 - Help (Defensive AIs)
# 14 - Exit Menu
# 15 - Starts Game

# Reset keepOption tag
tag @s remove keepOption

# Sound
execute at @s run playsound block.note_block.harp master @p ~ ~ ~ 0.5 1



# Main menu
tellraw @s[scores={options=1}] [{"text":"\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\nClick an option in chat to select it:\n","color":"gray","italic":"true"},{"text":"[GAME LENGTH] ","bold":"true","clickEvent":{"action":"run_command","value":"/trigger options set 2"},"hoverEvent":{"action":"show_text","value":"Adjust the length of the game"}},{"text":"[AI OPTIONS]","bold":"true","clickEvent":{"action":"run_command","value":"/trigger options set 5"},"hoverEvent":{"action":"show_text","value":"Change the number of AIs guarding each base"}},{"text":"\n\n[EXIT MENU]","bold":"true","clickEvent":{"action":"run_command","value":"/trigger options set 14"},"hoverEvent":{"action":"show_text","value":"Clears this menu"}}]

# Adjust game length
execute if score minutesInGame timer matches 5 run tellraw @s[scores={options=2}] [{"text": "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\nCurrent Length: ","color": "gray","italic": "true"}, {"score": {"name": "minutesInGame","objective": "timer"}}, {"text": " Minutes "}, {"text": "[-5] ","bold": "true","color": "dark_gray","hoverEvent": {"action": "show_text","value": "Game is at minimum length"}}, {"text": "[+5]","bold": "true","clickEvent": {"action": "run_command","value": "/trigger options set 9"},"hoverEvent": {"action": "show_text","value": "Increase game time by five minutes"}}, {"text": "\n\n[RETURN TO MENU]","bold": "true","clickEvent": {"action": "run_command","value": "/trigger options set 1"},"hoverEvent": {"action": "show_text","value": "Return to main options menu"}}]
execute if score minutesInGame timer matches 10..55 run tellraw @s[scores={options=2}] [{"text": "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\nCurrent Length: ","color": "gray","italic": "true"}, {"score": {"name": "minutesInGame","objective": "timer"}}, {"text": " Minutes "}, {"text": "[-5] ","bold": "true","clickEvent": {"action": "run_command","value": "/trigger options set 8"},"hoverEvent": {"action": "show_text","value": "Decrease game time by five minutes"}}, {"text": "[+5]","bold": "true","clickEvent": {"action": "run_command","value": "/trigger options set 9"},"hoverEvent": {"action": "show_text","value": "Increase game time by five minutes"}}, {"text": "\n\n[RETURN TO MENU]","bold": "true","clickEvent": {"action": "run_command","value": "/trigger options set 1"},"hoverEvent": {"action": "show_text","value": "Return to main options menu"}}]
execute if score minutesInGame timer matches 60 run tellraw @s[scores={options=2}] [{"text": "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\nCurrent Length: ","color": "gray","italic": "true"}, {"score": {"name": "minutesInGame","objective": "timer"}}, {"text": " Minutes "}, {"text": "[-5] ","bold": "true","clickEvent": {"action": "run_command","value": "/trigger options set 8"},"hoverEvent": {"action": "show_text","value": "Decrease game time by five minutes"}}, {"text": "[+5]","bold": "true","color": "dark_gray","hoverEvent": {"action": "show_text","value": "Game is at maximum length"}}, {"text": "\n\n[RETURN TO MENU]","bold": "true","clickEvent": {"action": "run_command","value": "/trigger options set 1"},"hoverEvent": {"action": "show_text","value": "Return to main options menu"}}]

# Help menu
tellraw @s[scores={options=3}] [{"text":"\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\nWhere specifically would you like help?\n","color":"gray","italic":"true"},{"text":"[FLAG MECHANICS] ","bold":"true","clickEvent":{"action":"run_command","value":"/trigger options set 11"},"hoverEvent":{"action":"show_text","value":"How to capture and return the flag"}},{"text":"[MAP LAYOUT] ","bold":"true","clickEvent":{"action":"run_command","value":"/trigger options set 10"},"hoverEvent":{"action":"show_text","value":"Information regarding the layout of the game map"}},{"text":"\n[SCARAB ELYTRA] ","bold":"true","clickEvent":{"action":"run_command","value":"/trigger options set 12"},"hoverEvent":{"action":"show_text","value":"How to fly with the Scarab Elytra"}},{"text":"[DEFENSIVE AIs]","bold":"true","clickEvent":{"action":"run_command","value":"/trigger options set 13"},"hoverEvent":{"action":"show_text","value":"How to view the time left in the game"}},{"text":"\n\n[EXIT MENU]","bold":"true","clickEvent":{"action":"run_command","value":"/trigger options set 14"},"hoverEvent":{"action":"show_text","value":"Clears this menu"}}]

# Start menu prep
scoreboard players set playerCount timer 0
execute as @a[team=!Spectators] run scoreboard players add playerCount timer 1
execute if score playerCount timer matches ..5 if score AIcount timer matches 0 run tag @s add promptAI

# Start menu (conditions met)
tellraw @s[scores={options=4},tag=!promptAI] [{"text":"\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\nAre you sure you would like to start the game?\n","color":"gray","italic":"true"},{"text":"[CONFIRM GAME START] ","bold":"true","color":"green","clickEvent":{"action":"run_command","value":"/trigger options set 15"},"hoverEvent":{"action":"show_text","value":"Start playing!"}},{"text":"\n\n[EXIT MENU]","bold":"true","clickEvent":{"action":"run_command","value":"/trigger options set 14"},"hoverEvent":{"action":"show_text","value":"Clears this menu"}}]
tellraw @s[scores={options=4},tag=promptAI] [{"text": "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\nAre you sure you would like to start the game?\nThere are fewer than six players and no AIs, so flags may be hard to defend. Would you like to increase the AI count?\n\n","color": "gray","italic": "true"}, {"text": "[START WITHOUT AI] ","bold": "true","color": "green","clickEvent": {"action": "run_command","value": "/trigger options set 15"},"hoverEvent": {"action": "show_text","value": "Start playing!"}}, {"text": "\n[INCREASE AI COUNT] ","bold": "true","clickEvent": {"action": "run_command","value": "/trigger options set 5"},"hoverEvent": {"action": "show_text","value": "Add some AIs before you play!"}}, {"text": "\n\n[RETURN TO MENU]","bold": "true","clickEvent": {"action": "run_command","value": "/trigger options set 1"},"hoverEvent": {"action": "show_text","value": "Return to main options menu"}}]
tag @s remove promptAI

# AI Settings
execute if score AIcount timer matches 0 run tellraw @s[scores={options=5}] [{"text": "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\nCurrent Count: ","color": "gray","italic": "true"}, {"score": {"name": "AIcount","objective": "timer"}}, {"text": " AIs per base "}, {"text": "[-1] ","bold": "true","color": "dark_gray","hoverEvent": {"action": "show_text","value": "There are no AIs left to remove"}}, {"text": "[+1]","bold": "true","clickEvent": {"action": "run_command","value": "/trigger options set 7"},"hoverEvent": {"action": "show_text","value": "Add one AI to each base"}}, {"text": "\n\n[RETURN TO MENU]","bold": "true","clickEvent": {"action": "run_command","value": "/trigger options set 1"},"hoverEvent": {"action": "show_text","value": "Return to main options menu"}}]
execute if score AIcount timer matches 1..4 run tellraw @s[scores={options=5}] [{"text": "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\nCurrent Count: ","color": "gray","italic": "true"}, {"score": {"name": "AIcount","objective": "timer"}}, {"text": " AIs per base "}, {"text": "[-1] ","bold": "true","clickEvent": {"action": "run_command","value": "/trigger options set 6"},"hoverEvent": {"action": "show_text","value": "Remove one AI from each base"}}, {"text": "[+1]","bold": "true","clickEvent": {"action": "run_command","value": "/trigger options set 7"},"hoverEvent": {"action": "show_text","value": "Add one AI to each base"}}, {"text": "\n\n[RETURN TO MENU]","bold": "true","clickEvent": {"action": "run_command","value": "/trigger options set 1"},"hoverEvent": {"action": "show_text","value": "Return to main options menu"}}]
execute if score AIcount timer matches 5 run tellraw @s[scores={options=5}] [{"text": "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\nCurrent Count: ","color": "gray","italic": "true"}, {"score": {"name": "AIcount","objective": "timer"}}, {"text": " AIs per base "}, {"text": "[-1] ","bold": "true","clickEvent": {"action": "run_command","value": "/trigger options set 6"},"hoverEvent": {"action": "show_text","value": "Remove one AI from each base"}}, {"text": "[+1]","bold": "true","color": "dark_gray","hoverEvent": {"action": "show_text","value": "There are a maximum of 5 AI per base"}}, {"text": "\n\n[RETURN TO MENU]","bold": "true","clickEvent": {"action": "run_command","value": "/trigger options set 1"},"hoverEvent": {"action": "show_text","value": "Return to main options menu"}}]

# Change AI Count
execute if score @s options matches 6 if score AIcount timer matches 1..5 run scoreboard players remove AIcount timer 1
execute if score @s options matches 7 if score AIcount timer matches 0..4 run scoreboard players add AIcount timer 1
execute at @s if score @s options matches 6 run tellraw @a[distance=0.1..] [{"color": "gold","text": "The AI count has been decreased to "}, {"score": {"name": "AIcount","objective": "timer"}}, {"text": " per base."}]
execute at @s if score @s options matches 7 run tellraw @a[distance=0.1..] [{"color": "gold","text": "The AI count has been increased to "}, {"score": {"name": "AIcount","objective": "timer"}}, {"text": " per base."}]
tag @s[scores={options=6..7}] add keepOption
scoreboard players set @s[scores={options=6..7}] options 5

# Change game length
execute if score @s options matches 8 if score minutesInGame timer matches 10..60 run scoreboard players remove minutesInGame timer 5
execute if score @s options matches 9 if score minutesInGame timer matches 5..55 run scoreboard players add minutesInGame timer 5
execute at @s if score @s options matches 8 run tellraw @a[distance=0.1..] [{"color": "gold","text": "The game length has been decreased to "}, {"score": {"name": "minutesInGame","objective": "timer"}}, {"text": " Minutes."}]
execute at @s if score @s options matches 9 run tellraw @a[distance=0.1..] [{"color": "gold","text": "The game length has been increased to "}, {"score": {"name": "minutesInGame","objective": "timer"}}, {"text": " Minutes."}]
tag @s[scores={options=8..9}] add keepOption
scoreboard players set @s[scores={options=8..9}] options 2

# Help Submenus
tellraw @s[scores={options=10}] [{"text": "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n• Each team has a base, with a flag.\n• There are two main lanes connecting the bases, with a third lane accessible from the middle.\n• A shortcut to the Scarab Elytra opens from each spawn if the Elytra are present.\n","color": "gray","italic": "true"}, {"text": "\n[RETURN TO HELP MENU]","bold": "true","clickEvent": {"action": "run_command","value": "/trigger options set 3"},"hoverEvent": {"action": "show_text","value": "Return to the help menu"}}]
tellraw @s[scores={options=11}] [{"text": "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n• Each team has a flag in their base.\n• You can pick up the other team's flag.\n• If you die, the flag falls and can be returned by the enemy or picked up by a teammate.\n• A pillar of particles will show the current position of any flag.\n• Return the flag to your base's flag location for a point.\n","color": "gray","italic": "true"}, {"text": "\n[RETURN TO HELP MENU]","bold": "true","clickEvent": {"action": "run_command","value": "/trigger options set 3"},"hoverEvent": {"action": "show_text","value": "Return to the help menu"}}]
tellraw @s[scores={options=12}] [{"text": "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n• The Scarab Elytra are single-use Elytra that spawn in the center of the upper path.\n• Press space while falling to activate them.\n• You cannot use them while carrying a flag.\n• They automatically respawn 20 seconds after they break.\n","color": "gray","italic": "true"}, {"text": "\n[RETURN TO HELP MENU]","bold": "true","clickEvent": {"action": "run_command","value": "/trigger options set 3"},"hoverEvent": {"action": "show_text","value": "Return to the help menu"}}]
tellraw @s[scores={options=13}] [{"text": "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n• Depending on the settings, there may be as many as 5 defensive AIs guarding each base.\n• Like everything else, they cause instant kills, so be careful!\n• They may change their weapon depending on the situation.\n• When killed, they respawn in 30 seconds.\n","color": "gray","italic": "true"}, {"text": "\n[RETURN TO HELP MENU]","bold": "true","clickEvent": {"action": "run_command","value": "/trigger options set 3"},"hoverEvent": {"action": "show_text","value": "Return to the help menu"}}]

# Exit menu (clear chat)
tellraw @a[scores={options=14..15}] {"text":"\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n"}

# Start game
execute if score @s options matches 15 unless entity @a[team=!Spectators] run tellraw @a {"italic":"true","color":"gray","text":"You can't just start a game without anyone to play it, silly! Get out of spectator mode and try again!"}
execute if score @s options matches 15 if entity @a[team=!Spectators] run function votk:progress/start1



# Prep for next selection
scoreboard players enable @s options
scoreboard players set @s[tag=!keepOption] options 0

# Is this needed anymore?
#/scoreboard players set @a[tag=goToGameLength] options 2
#/scoreboard players set @a[tag=goToAIcount] options 5
#/scoreboard players tag @a[tag=goToGameLength] remove goToGameLength
#/scoreboard players tag @a[tag=goToAIcount] remove goToAIcount