## Randomize teams for anyone in the "randomize" team at start
# Runs recursively one at a time on any "lobby" players until all are sorted

# Reset the counts
scoreboard players set egypCount timer 0
scoreboard players set archCount timer 0

# Set the counts
execute as @a[team=Egyptians] run scoreboard players add egypCount timer 1
execute as @a[team=Archaeologists] run scoreboard players add archCount timer 1

# See which one is smaller
scoreboard players operation archCount timer -= egypCount timer
# If archCount is negative, there are more Egyptians. If positive, there are more Archaeologists.

# This shouldn't be necessary, but remove from lobby team
team leave

# Add the player to the team with fewer people (or if they are equal, to the Archaeologists)
execute if score archCount timer matches 1.. run team join Egyptians @s
execute if score archCount timer matches ..0 run team join Archaeologists @s

# Print their newfound allies in chat
tellraw @s[team=Egyptians] {"text":"You have been randomly assigned to the Egyptians!","color":"blue"}
tellraw @s[team=Archaeologists] {"text":"You have been randomly assigned to the Archaeologists!","color":"dark_red"}

# Run again if anyone is left in the lobby team
execute as @r[team=Lobby] run function votk:teams/team_randomize